/*global define, CKEDITOR, setTimeout*/
/*jslint regexp: true, unparam: true*/
define([
    'testsuite/qunit',
    'jquery',
    'ep/ui/editor',
    'testsuite/qunit-fixture!ckeditor/plugins/eptableclass/plugin-test',

    '$ready!'
    ], function (QUnit, $, ep, fixture) {
    'use strict';

    QUnit.module("ckeditor/plugins/eptableclass", {
        teardown: fixture.destroy
    });

    QUnit.fixtureVar = fixture;

        QUnit.asyncTest("basic eplineheight plugin tests", function () {

            // Clear HTML-Remains, initiate Fixture and initiate Editor
            QUnit.fixtureVar.init();

            ep('#uieditor_ckeditortestinstance_test1').uiEditor({
                'name' : 'ckeditortestinstance_test1',
                'blogPostMode': true
            });

            setTimeout(function () {
                var editorClass = 'cke_1',
                    editorInstance = CKEDITOR.instances.uieditor_ckeditortestinstance_test1,
                    dialog;

                // Reset CKE data.
                editorInstance.setData('');

                // open table dialog
                dialog = editorInstance.openDialog('eptable');

                setTimeout(function () {
                    // close dialog
                    $('.' + editorClass + ' .cke_dialog_ui_button_ok span').trigger('click');

                    // open dialog again and get its instance
                    dialog = editorInstance.openDialog('eptable');
                    setTimeout(function () {

                        // test if correct CSS class is set
                        QUnit.equal(
                            dialog.definition.getContents('advanced').get('advCSSClasses')['default'],
                            'cke-table',
                            'default class for table dialog is set to "cke-table"'
                        );

                        setTimeout(function () {
                            // close dialog
                            $('.' + editorClass + ' .cke_dialog_ui_button_cancel span').trigger('click');

                            // Close submenu.
                            editorInstance.focus();

                            setTimeout(function () {

                                setTimeout(function () {
                                    var data = editorInstance.getData(),
                                        fragment = $("<div />").html(data),
                                        table = fragment.find('table');

                                    // test if inserted table has CSS class "cke-table"
                                    QUnit.equal(
                                        table.hasClass('cke-table'),
                                        true,
                                        'inserted table has CSS class "cke-table"'
                                    );

                                    QUnit.start();
                                }, 400);

                            }, 400);
                       }, 400);
                    }, 500);

                }, 500);
            }, 4000);
        });


});